;##############################################################################;
;ROM template
use16
org 0
;##############################################################################;
macro printx x{
 local strng,next
 mov  si,strng
 call print
 jmp next
 strng db x,0
 next:
}
;##############################################################################;
macro printxln x{
 local strng,next
 mov  si,strng
 call print
 jmp next
 strng db x,0
 next:
 mov  si,newline
 call print
}
;##############################################################################;
ROM_SIZE=1          ;ROM size in 2Kb blocks
dw 0AA55h           ;BIOS signature
db ROM_SIZE*4       ;Size in 512 blocks
;##############################################################################;
start:
push cs
pop  ds

printxln "===Updates A==="
printxln "-int 6h Error intercept"
printxln "-int 77h floppy change hack"
printxln "-1.44M floppy support"

push ds
mov  cx,cs
xor  ax,ax
mov  ds,ax

;Set int 6
mov  word [ds:06h*4],int_06
mov  word [ds:06h*4+2],cx

;Update table
mov  word [ds:1Eh*4],fdd_144
mov  word [ds:1Eh*4+2],cx

;Set int 13h
mov  word [ds:13h*4],int_13_ext
mov  word [ds:13h*4+2],cx

;Set int 77h
mov  word [ds:77h*4],int_77_ext
mov  word [ds:77h*4+2],cx
pop  ds


;Reset
mov  dl,0
mov  ax,0
int  13h
mov  dl,1
mov  ax,0
int  13h
mov  dl,2
mov  ax,0
int  13h
mov  dl,3
mov  ax,0
int  13h

;db 0FFh
;db 0FFh

retf
;##############################################################################;
int_06:
cli
mov ax,600h
mov ss,ax
mov ax,cs
mov ds,ax
mov es,ax
mov sp,100h

;Reset screen
mov ah,0
mov al,3
int 10h

printxln "Incorrect opcode intercepted"
printxln "Rebooting..."
mov cx,08Fh
lpo:
push cx
mov cx,0FFFFh
loop $
pop cx
loop lpo

jmp far 0F000h:0FFF0h
;##############################################################################;
;INT 13 - DISK - GET DRIVE PARAMETERS (PC,XT286,CONV,PS,ESDI,SCSI)
;	AH = 08h
;	DL = drive (bit 7 set for hard disk)
;	ES:DI = 0000h:0000h to guard against BIOS bugs
;Return: CF set on error
;	    ah = status (07h) (see #00234)
;	CF clear if successful
;	    AH = 00h
;	    AL = 00h on at least some BIOSes
;	    BL = drive type (AT/PS2 floppies only) (see #00242)
;	    CH = low eight bits of maximum cylinder number
;	    CL = maximum sector number (bits 5-0)
;		 high two bits of maximum cylinder number (bits 7-6)
;	    DH = maximum head number
;	    DL = number of drives
;	    ES:DI -> drive parameter table (floppies only)
;
;Values for diskette drive type:
; 01h	360K
; 02h	1.2M
; 03h	720K
; 04h	1.44M
; 05h	??? (reportedly an obscure drive type shipped on some IBM machines)
;	2.88M on some machines (at least AMI 486 BIOS)
; 06h	2.88M
; 10h	ATAPI Removable Media Device

;##############################################################################;
int_13_ext:
sti
cmp  ah,8
je   func_08
cmp  ah,17h
je   func_17
jmp  eoi

func_08:
and dl,10000000b
jz  fd8
stc
mov ah,07h
mov al,0
retf 2

fd8:
mov ax,cs
mov es,ax
mov di,fdd_144

mov ax,0
mov ch,79
mov cl,18
mov dh,1
mov dl,4
mov bl,04h
mov bh,04h

clc
retf 2


func_17:
clc
mov ah,0
retf 2

eoi:
;jmp far [cs:old_int]
jmp far 0F000h:0EC59h ;int13 default
;##############################################################################;
int_77_ext:
cmp ax,0AEh
jne finita
mov dx,3FFh
out dx,al
jmp finita

finita:
iret
;##############################################################################;
;old_int dd 0
newline db 0Dh,0Ah,0
fdd_144:
;Disk parameter table 1
db      10101111b             ;Disk Controller Mode byte 1          
db      2                     ;Disk Controller Mode byte 2
db      19h                   ;clock ticks until motor off
db      2                     ;FM or MFM Mode: Log2 (Bytes per Sector/128)
db      18                    ;last sector on track
db      1Bh                   ;gap length in bytes
db      0FFh                  ;disk data length
db      6Ch                   ;gap length when formatting
db      0F6h                  ;data pattern used during formatting
db      0Fh                   ;floppy head bounce delay (in milliseconds)
db      8                     ;floppy motor start delay (in 0.125 second intervals)
;##############################################################################;
include "unitools.asm"
;##############################################################################;
rb ROM_SIZE*2048-3-$
dw 086AEh           ;E8086 signature
rb 1                ;Checksum
;##############################################################################;