;##############################################################################;
LF=0Ah
CR=0Dh
;##############################################################################;
print_hexbyte: 
push    ax                              ;Save number
mov     cl,4
shr     al,cl
call    print_hexdigit                  ;Out first  digit
pop     ax
call    print_hexdigit                  ;Out second digit
ret
;##############################################################################;
print_hexword: 
push    ax                              ;Unsigned word
mov     al,ah
call    print_hexbyte
pop     ax
call    print_hexbyte
ret
;##############################################################################;
out_chr: 
push    bx
push    ax
mov     ah,0Eh                          ;Teletype print service
mov     bl,7                            ; ...normal intensity
int     10h
pop     ax
pop     bx
ret
;##############################################################################;
print_hexdigit:  
push    ax                              ;Print hex digit in al
and     al,0Fh
cmp     al,9
jbe     D_01
add     al,'A'-'9'-1

D_01:   
add     al,'0'                          ;Make ascii digit
call    out_chr                         ;...print it
pop     ax
ret

mov     al,CR                           ;Print carriage return
call    out_chr                         ; ...on screen
mov     al,LF                           ;Print line feed
call    out_chr                         ; ...on screen
ret
;##############################################################################;
getch:  
mov     ah,0                            ;Read keyboard key
int     16h
ret
;##############################################################################;
print:  
lodsb                                   ;Print zero terminated string
or      al,al
jnz     print1                          ; ...not terminator in ax
ret

print1: 
call    out_chr                         ;Print character in ax
jmp     print                           ; ...back for more
;##############################################################################;
beep:   
push    ax
push    cx
mov     al,10110110b                    ;Timer ic 8253 square waves
out     43h,al                          ; ...channel 2, speaker
mov     ax,528h                         ;Get countdown constant word
out     42h,al                          ; ...send lo order
mov     al,ah                           ; ...load hi order
out     42h,al                          ; ...send hi order
in      al,61h                          ;Read ic 8255 machine status
push    ax
or      al,00000011b
out     61h,al                          ;Turn speaker on
xor     cx,cx

beep_1: 
loop    beep_1
dec     bl
jnz     beep_1
pop     ax
out     61h,al                          ;Turn speaker off
pop     cx
pop     ax
ret
;##############################################################################;
